package serveurenseignant;

import java.util.*;
import java.util.function.Predicate;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author cf
 */
public class Enseignant {

    /**
     * @param args the command line arguments
     */
    public String nom;
    public int age;
    public int salaire;
    public Grade grade;
    public static enum Grade {
        PU ("PU"), 
        MCU ("MCU"), 
        PRAG ("PRAG"), 
        BIATTS ("BIATTS"), 
        PUPH ("PUPH"), 
        MCUPH ("MCUPH");
        private final String grade;
        Grade(String grade) {
            this.grade=grade;
        }
    }
    public static List<Enseignant> personnel = new ArrayList();

    public String getNom() {
        return nom;
    }

    public void setNom(String nom) {
        this.nom = nom;
    }

    public int getAge() {
        return age;
    }

    public void setAge(int age) {
        this.age = age;
    }

    public int getSalaire() {
        return salaire;
    }

    public void setSalaire(int salaire) {
        this.salaire = salaire;
    }

    public String getGrade() {
        return grade.grade;
    }

    public void setGrade(Grade grade) {
        this.grade = grade;
    }

    public static List<Enseignant> getPersonnel() {
        return personnel;
    }

    public static void setPersonnel(List<Enseignant> personnel) {
        Enseignant.personnel = personnel;
    }
    
    public static void addEnseignant(Enseignant enseignant) {
        Enseignant.personnel.add(enseignant);
    }
    
    Enseignant(String nom, int age, int salaire, Grade grade) {
        this.nom = nom;
        this.age = age;
        this.salaire = salaire;
        this.grade = grade;
    }
    
    public static Enseignant findEnseignantByNom(String nom) {
        Predicate<Enseignant> isFound = e -> e.nom.equals(nom);
//        Predicate<Enseignant> isFound = e -> {
//           e.getClass().getDeclaredField(nom).equals(nom);
//        };
        Enseignant e = Enseignant.personnel.stream().
                filter(isFound).findFirst().get();
        return e;
    }
    
    public static double moyenneByAge() {
        return Enseignant.personnel
                         .stream()
                         .mapToDouble(e->e.getAge())
                         .average()
                         .getAsDouble();
    }
    
    public static double moyenneByGrade(String grade) {
        Predicate<Enseignant> isGrade = e -> e.grade.grade.equals(grade);
        return Enseignant.personnel
                         .stream()
                         .filter(isGrade)
                         .mapToDouble(e->e.getAge())
                         .average()
                         .getAsDouble();
    }
    
    public static double moyenneByAge(int min, int max) {
        Predicate<Enseignant> isBetween = 
                e -> (e.age > min && e.age < max);
        return Enseignant.personnel
                         .stream()
                         .filter(isBetween)
                         .mapToDouble(e->e.getAge())
                         .average()
                         .getAsDouble();
    }
    
    @Override
    public String toString() {
        return getNom() + " " + getAge() + "ans";
    }
    
}
