/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package serveurenseignant;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.Socket;
import java.util.concurrent.CompletionService;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorCompletionService;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.function.Consumer;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.stream.Stream;

/**
 *
 * @author cf
 */
public class Esclave implements Runnable {
    private final Socket socket;
    private final Serveur serveur;
    Esclave(Socket socket, Serveur serveur) {
        this.socket = socket;
        this.serveur = serveur;
    }
        
    @Override
    public void run() {
        try { 
            BufferedReader input = new BufferedReader(
                new InputStreamReader(socket.getInputStream(),
                            "8859_1"),1024); // flux en lecture
            StringBuffer sb = new StringBuffer();
            sb.append(input.readLine());
            System.out.println(sb);
            String[] commande = sb.toString().split(" ");
            switch (commande[0]) {
                case "Recherche": System.out.println(
                        Enseignant.findEnseignantByNom(commande[1]));
                    break;
                case "TestPrimalitéSimple":   // question 1.6
                        premierAvecAttente(Integer.parseInt(commande[1]));
                    break;
                case "TestPrimalitéMultiple":   // question 1.7
                        premierAvecCompletion (commande);
                    break;
                case "TestPrimalitéMultipleStream":   // question 1.8
                        premierAvecCompletionStream (Stream.of(commande));
                    break;
                case "Fin": serveur.setIsFinished(true);
                    break;
                default: ;
            }
        }
        catch (IOException e) {System.out.println(e);}
        finally {
            try { if (socket != null) socket.close();}
            catch (IOException e) {}
        }
    }

    public void premierAvecAttente (int n) {
        // test premier
        ExecutorService executor = Executors.newSingleThreadExecutor();
        Future<Pair> future = executor.submit(new EsclavePremier(n));
        // test de récup toutes les 10 secondes
        while (!future.isDone()) {
            try {
                synchronized (this) {
                    System.out.println("J'attends !");
                    this.wait(1000);
                }
            } catch (InterruptedException ex) {
                Logger.getLogger(Serveur.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        // récup directe
        try {
            System.out.print("Le nombre " + n);
            if (future.get().getB()) System.out.println(" est premier.");
            else System.out.println(" n'est pas premier.");
        } catch (ExecutionException ex) {} catch (InterruptedException ex) {
            Logger.getLogger(Serveur.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    
    public void premierAvecCompletion (String[] s) {
        // remplacer le submit manuel par un buffredreader avec sortie en stream
        // test premier
        ExecutorService executor = Executors.newSingleThreadExecutor();
        CompletionService<Pair> completionService = new ExecutorCompletionService<Pair>(executor);
        for(int i=1;i<=10;i++) {
            completionService.submit(new EsclavePremier(Integer.parseInt(s[i])));            
        }
        while ( true ) {
            try {
                Future<Pair> future2 = completionService.take();
                System.out.print("[CompletionService] Le nombre " + future2.get().getN());
                if (future2.get().getB()) System.out.println(" est premier.");
                else System.out.println(" n'est pas premier.");
            } catch (InterruptedException | ExecutionException ex) {
                Logger.getLogger(Serveur.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
    
    public void premierAvecCompletionStream (Stream<String> streamString) {
        // remplacer le submit manuel par un buffredreader avec sortie en stream
        // test premier
        ExecutorService executor = Executors.newSingleThreadExecutor();
        CompletionService<Pair> completionService = new ExecutorCompletionService<Pair>(executor);
        
        Consumer<String> testPrimalite
                = (String s) -> {
                    completionService.submit(new EsclavePremier(Integer.parseInt(s)));
                };
        streamString.skip(1)
                    .forEach(testPrimalite);
        while ( true ) {
            try {
                Future<Pair> future2 = completionService.take();
                System.out.print("[CompletionService] Le nombre " + future2.get().getN());
                if (future2.get().getB()) System.out.println(" est premier.");
                else System.out.println(" n'est pas premier.");
            } catch (InterruptedException | ExecutionException ex) {
                Logger.getLogger(Serveur.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
    }
    

}
