package serveurenseignant;

import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.logging.Level;
import java.util.logging.Logger;
import serveurenseignant.Enseignant.Grade;

/**
 *
 * @author cf
 */
public class Serveur {
    private ServerSocket serverSocket;
    private Socket socket;
    public static final int port = 33333;
    private static final int poolSize = 10;
    private ExecutorService pool = null;
    private Boolean isFinished = false;

    public Boolean getIsFinished() {
        return isFinished;
    }

    public void setIsFinished(Boolean isFinished) {
        this.isFinished = isFinished;
    }
    
    Serveur(int port, int size) {
        initEnseignant();
        try {
            serverSocket = new ServerSocket(port,size);
            pool = Executors.newFixedThreadPool(poolSize);
        } catch (IOException ex) {
            Logger.getLogger(Serveur.class.
                    getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void initEnseignant() {
        Enseignant e1 = new Enseignant("xx",33,2000,Grade.valueOf("PU"));
        Enseignant e2 = new Enseignant("yy",23,1000,Grade.valueOf("PU"));
        Enseignant e3 = new Enseignant("zz",43,3000,Grade.valueOf("PRAG"));
        Enseignant e4 = new Enseignant("tt",50,2000,Grade.valueOf("MCU"));
        Enseignant.addEnseignant(e1);
        Enseignant.addEnseignant(e2);
        Enseignant.addEnseignant(e3);
        Enseignant.addEnseignant(e4);
    }
    
    public void manageEnseignant() {
        // requêtes enseignants
        while (!isFinished) {
            try { 
                pool.execute(new Esclave(serverSocket.accept(),this));
            }
            catch (IOException e) {System.out.println(e);}
            finally {
                try { if (socket != null) socket.close();}
                catch (IOException e) {}
            }
        }
    }
    
    public ServerSocket getServerSocket() {
        return serverSocket;
    }

    public void setServerSocket(ServerSocket serverSocket) {
        this.serverSocket = serverSocket;
    }

    public Socket getSocket() {
        return socket;
    }

    public void setSocket(Socket socket) {
        this.socket = socket;
    }
    
}
